/*
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import org.openapitools.client.model.InstanceStatusStatusData;

/**
 * InstanceStatus
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2019-10-24T15:11:21.199Z[GMT]")
public class InstanceStatus {
  /**
   * Instance Status
   */
  @JsonAdapter(AccountStatusEnum.Adapter.class)
  public enum AccountStatusEnum {
    GOT_QR_CODE("got qr code"),
    
    AUTHENTICATED("authenticated"),
    
    LOADING("loading"),
    
    INIT("init"),
    
    NOT_PAID("not_paid");

    private String value;

    AccountStatusEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static AccountStatusEnum fromValue(String value) {
      for (AccountStatusEnum b : AccountStatusEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<AccountStatusEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final AccountStatusEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public AccountStatusEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return AccountStatusEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_ACCOUNT_STATUS = "accountStatus";
  @SerializedName(SERIALIZED_NAME_ACCOUNT_STATUS)
  private AccountStatusEnum accountStatus;

  public static final String SERIALIZED_NAME_QR_CODE = "qrCode";
  @SerializedName(SERIALIZED_NAME_QR_CODE)
  private byte[] qrCode;

  public static final String SERIALIZED_NAME_STATUS_DATA = "statusData";
  @SerializedName(SERIALIZED_NAME_STATUS_DATA)
  private InstanceStatusStatusData statusData;


  public InstanceStatus accountStatus(AccountStatusEnum accountStatus) {
    
    this.accountStatus = accountStatus;
    return this;
  }

   /**
   * Instance Status
   * @return accountStatus
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "got qr code", value = "Instance Status")

  public AccountStatusEnum getAccountStatus() {
    return accountStatus;
  }



  public void setAccountStatus(AccountStatusEnum accountStatus) {
    this.accountStatus = accountStatus;
  }


  public InstanceStatus qrCode(byte[] qrCode) {
    
    this.qrCode = qrCode;
    return this;
  }

   /**
   * Base64-encoded contents of the QR code
   * @return qrCode
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Base64-encoded contents of the QR code")

  public byte[] getQrCode() {
    return qrCode;
  }



  public void setQrCode(byte[] qrCode) {
    this.qrCode = qrCode;
  }


  public InstanceStatus statusData(InstanceStatusStatusData statusData) {
    
    this.statusData = statusData;
    return this;
  }

   /**
   * Get statusData
   * @return statusData
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public InstanceStatusStatusData getStatusData() {
    return statusData;
  }



  public void setStatusData(InstanceStatusStatusData statusData) {
    this.statusData = statusData;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InstanceStatus instanceStatus = (InstanceStatus) o;
    return Objects.equals(this.accountStatus, instanceStatus.accountStatus) &&
        Arrays.equals(this.qrCode, instanceStatus.qrCode) &&
        Objects.equals(this.statusData, instanceStatus.statusData);
  }

  @Override
  public int hashCode() {
    return Objects.hash(accountStatus, Arrays.hashCode(qrCode), statusData);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InstanceStatus {\n");
    sb.append("    accountStatus: ").append(toIndentedString(accountStatus)).append("\n");
    sb.append("    qrCode: ").append(toIndentedString(qrCode)).append("\n");
    sb.append("    statusData: ").append(toIndentedString(statusData)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

